# newsleaf.tcl v1.3 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# this is the leaf tcl for my newsposting systems:
# the script will redirect the newslines which have been searched by the
# hub bots scripts to the channels you want. the big avantage of this 
# hub/leaf system is that only one bot has to check for news - the others
# can idle and dont lag. perfectly a limbo hub would do the newssearching 
# job. the only requirement for this tcl to work is that the bots are linked,
# but no special flags are required. so also bots on completely differen irc
# networks can post the news a bot in another irc network discovered - this
# is the best way to minimize traffic on the affected homepages and on your
# bots.
# the following tcls are currently supported:
#
# -heise.tcl (www.heise.de)
# -ok.tcl (www.onlinekosten.de)
# -zdnet.tcl (www.zdnet.net)
# -gamestar.tcl (www.gamestar.de)
# -pcgames.tcl (www.pcgames.de)
# -lanparty.tcl (www.lanparty.de)
# -ran.tcl (www.ran.de www.sport1.de)
# -ssn.tcl (www.shortnews.de)
# -bugtraq.tcl (packetstorm.securify.com)
# -mikemth.tcl (www.mikemth.de)
# -ntv.tcl (www.ntv.de)
# -sharereactor.tcl (www.sharereactor.com)
# -slashdot.tcl (www.slashdot.com)
# -spiegel.tcl (www.spiegel.de)
# -zone-h.tcl (www.zone-h.com)
# -rotten.tcl (www.rotten.com)
# -winfuture.tcl (www.winfuture.de)
# -cs-zone.tcl (www.cstrike-zone.de)
#
# get them @ www.domsen.org
#
# v1.3 - more scripts have been added, old ones have been removed
# v1.2 - first public version
#
####### config ######################
# should the bot be a hub for the specific tcl?
# 0 = no / 1 = yes

set isheiseleaf "0"
set isokleaf "0"
set iszdnetleaf "0"
set isgamestarleaf "0"
set ispcgamesleaf "0"
set islanpartyleaf "0"
set isranleaf "0"
set issnleaf "0"

set isbugtraqleaf "0"
set ismikemthleaf "0"
set isntvleaf "0"
set issrleaf "0"
set isslashdotleaf "0"
set isspiegelleaf "0"
set isrottenleaf "0"
set iszoneleaf "0"
set isfreshmeatleaf "0"
set iswinfutureleaf "0"
set iscszoneleaf "0"

# to which chans should the tcl redirect the news?
# "" for all or "#chan1 #chan2 #chan3"

set heiseleafchans ""
set okleafchans ""
set zdnetleafchans ""
set gamestarleafchans ""
set pcgamesleafchans ""
set lanpartyleafchans ""
set ranleafchans ""
set snleafchans ""

set bugtraqleafchans ""
set mikemthleafchans ""
set ntvleafchans ""
set srleafchans ""
set slashdotleafchans ""
set spiegelleafchans ""
set rottenleafchans ""
set zoneleafchans ""
set freshmeatleafchans ""
set winfutureleafchans ""
set cszoneleafchans ""

# end of config

bind bot - heise: postheise
bind bot - onlinekosten: postok
bind bot - zdnet: postzdnet
bind bot - gamestar: postgamestar
bind bot - pcgames: postpcgames
bind bot - lanparty: postlanparty
bind bot - ran: postran
bind bot - ssn: postsn

bind bot - bugtraq: postbugtraq
bind bot - mike: postmikemth
bind bot - ntv: postntv
bind bot - sharereactor: postsr
bind bot - slashdot: postslashdot
bind bot - spiegel: postspiegel
bind bot - rotten: postrotten
bind bot - zone: postzone
bind bot - freshmeat: postfreshmeat
bind bot - winfuture: postwinfuture
bind bot - cszone: postcszone

proc postheise { frombot command arg } {
global isheiseleaf heiseleafchans
if { $isheiseleaf == "1" } {
putlog "($frombot) heise: neue newsline"
foreach chan [channels] {
if { $heiseleafchans == "" } {
putserv "privmsg $chan :(neue heise newsline) $arg" }
if { $heiseleafchans != "" } {
if {([lsearch -exact [string tolower $heiseleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue heise newsline) $arg"
}}}}}


proc postok { frombot command arg } {
global isokleaf okleafchans
if { $isokleaf == "1" } {
putlog "($frombot) onlinekosten.de: neue newsline"
foreach chan [channels] {
if { $okleafchans == "" } {
putserv "privmsg $chan :(neue onlinekosten newsline) $arg" }
if { $okleafchans != "" } {
if {([lsearch -exact [string tolower $okleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue onlinekosten newsline) $arg"
}}}}}


proc postzdnet { frombot command arg } {
global iszdnetleaf zdnetleafchans
if { $iszdnetleaf == "1" } {
putlog "($frombot) zdnet: neue newsline"
foreach chan [channels] {
if { $zdnetleafchans == "" } {
putserv "privmsg $chan :(neue zdnet newsline) $arg" }
if { $zdnetleafchans != "" } {
if {([lsearch -exact [string tolower $zdnetleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue zdnet newsline) $arg"
}}}}}


proc postgamestar { frombot command arg } {
global isgamestarleaf gamestarleafchans
if { $isgamestarleaf == "1" } {
putlog "($frombot) gamestar: neue newsline"
foreach chan [channels] {
if { $gamestarleafchans == "" } {
putserv "privmsg $chan :(neue gamestar newsline) $arg" }
if { $gamestarleafchans != "" } {
if {([lsearch -exact [string tolower $gamestarleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue gamestar newsline) $arg"
}}}}}


proc postpcgames { frombot command arg } {
global ispcgamesleaf pcgamesleafchans
if { $ispcgamesleaf == "1" } {
putlog "($frombot) pcgames: neue newsline"
foreach chan [channels] {
if { $pcgamesleafchans == "" } {
putserv "privmsg $chan :(neue pcgames newsline) $arg" }
if { $pcgamesleafchans != "" } {
if {([lsearch -exact [string tolower $pcgamesleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue pcgames newsline) $arg"
}}}}}


proc postlanparty { frombot command arg } {
global islanpartyleaf lanpartyleafchans
if { $islanpartyleaf == "1" } {
putlog "($frombot) lanparty.de: neue newsline"
foreach chan [channels] {
if { $lanpartyleafchans == "" } {
putserv "privmsg $chan :(neue lanparty.de newsline) $arg" }
if { $lanpartyleafchans != "" } {
if {([lsearch -exact [string tolower $lanpartyleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue lanparty.de newsline) $arg"
}}}}}


proc postran { frombot command arg } {
global isranleaf ranleafchans
if { $isranleaf == "1" } {
putlog "($frombot) ran: neue newsline"
foreach chan [channels] {
if { $ranleafchans == "" } {
putserv "privmsg $chan :(neue ran newsline) $arg" }
if { $ranleafchans != "" } {
if {([lsearch -exact [string tolower $ranleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue ran newsline) $arg"
}}}}}


proc postsn { frombot command arg } {
global issnleaf snleafchans
if { $issnleaf == "1" } {
putlog "($frombot) shortnews: neue newsline"
foreach chan [channels] {
if { $snleafchans == "" } {
putserv "privmsg $chan :(neue shortnews newsline) $arg" }
if { $snleafchans != "" } {
if {([lsearch -exact [string tolower $snleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue shortnews newsline) $arg"
}}}}}








proc postbugtraq { frombot command arg } {
global isbugtraqleaf bugtraqleafchans
if { $isbugtraqleaf == "1" } {
putlog "($frombot) bugtraq: new vulnerability"
foreach chan [channels] {
if { $bugtraqleafchans == "" } {
putserv "privmsg $chan :(new vulnerability) $arg" }
if { $bugtraqleafchans != "" } {
if {([lsearch -exact [string tolower $bugtraqleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(new vulnerability) $arg"
}}}}}


proc postmikemth { frombot command arg } {
global ismikemthleaf mikemthleafchans
if { $ismikemthleaf == "1" } {
putlog "($frombot) mikemth: neue newsline"
foreach chan [channels] {
if { $mikemthleafchans == "" } {
putserv "privmsg $chan :(neue mikemth.de newsline) $arg" }
if { $mikemthleafchans != "" } {
if {([lsearch -exact [string tolower $mikemthleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue mikemth.de newsline) $arg"
}}}}}


proc postntv { frombot command arg } {
global isntvleaf ntvleafchans
if { $isntvleaf == "1" } {
putlog "($frombot) ntv: neue newsline"
foreach chan [channels] {
if { $ntvleafchans == "" } {
putserv "privmsg $chan :(neue ntv newsline) $arg" }
if { $ntvleafchans != "" } {
if {([lsearch -exact [string tolower $ntvleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue ntv newsline) $arg"
}}}}}


proc postsr { frombot command arg } {
global issrleaf srleafchans
if { $issrleaf == "1" } {
putlog "($frombot) sharereactor: new release"
foreach chan [channels] {
if { $srleafchans == "" } {
putserv "privmsg $chan :(new sharereactor release) $arg" }
if { $srleafchans != "" } {
if {([lsearch -exact [string tolower $srleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(new sharereactor release) $arg"
}}}}}


proc  postslashdot { frombot command arg } {
global isslashdotleaf slashdotleafchans
if { $isslashdotleaf == "1" } {
putlog "($frombot) slashdot: new headline"
foreach chan [channels] {
if { $slashdotleafchans == "" } {
putserv "privmsg $chan :(new slashdot headline) $arg" }
if { $slashdotleafchans != "" } {
if {([lsearch -exact [string tolower $slashdotleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(new slashdot headline) $arg"
}}}}}

proc postspiegel { frombot command arg } {
global isspiegelleaf spiegelleafchans
if { $isspiegelleaf == "1" } {
putlog "($frombot) spiegel: neue newsline"
foreach chan [channels] {
if { $spiegelleafchans == "" } {
putserv "privmsg $chan :(neue spiegel newsline) $arg" }
if { $spiegelleafchans != "" } {
if {([lsearch -exact [string tolower $spiegelleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue spiegel newsline) $arg"
}}}}}


proc postrotten { frombot command arg } {
global isrottenleaf rottenleafchans
if { $isrottenleaf == "1" } {
putlog "($frombot) rotten: new headline"
foreach chan [channels] {
if { $rottenleafchans == "" } {
putserv "privmsg $chan :(new rotten headline) $arg" }
if { $rottenleafchans != "" } {
if {([lsearch -exact [string tolower $rottenleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(new rotten headline) $arg"
}}}}}


proc postzone { frombot command arg } {
global iszoneleaf zoneleafchans
if { $iszoneleaf == "1" } {
putlog "($frombot) zone: new defacement"
foreach chan [channels] {
if { $zoneleafchans == "" } {
putserv "privmsg $chan :(new defacement) $arg" }
if { $zoneleafchans != "" } {
if {([lsearch -exact [string tolower $zoneleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(new defacement) $arg"
}}}}}


proc postfreshmeat { frombot command arg } {
global isfreshmeatleaf freshmeatleafchans
if { $isfreshmeatleaf == "1" } {
putlog "($frombot) freshmeat: new release"
foreach chan [channels] {
if { $freshmeatleafchans == "" } {
putserv "privmsg $chan :(new freshmeat release) $arg" }
if { $freshmeatleafchans != "" } {
if {([lsearch -exact [string tolower $freshmeatleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(new freshmeat release) $arg"
}}}}}


proc postwinfuture { frombot command arg } {
global iswinfutureleaf winfutureleafchans
if { $iswinfutureleaf == "1" } {
putlog "($frombot) winfuture: neue newsline"
foreach chan [channels] {
if { $winfutureleafchans == "" } {
putserv "privmsg $chan :(neue winfuture newsline) $arg" }
if { $winfutureleafchans != "" } {
if {([lsearch -exact [string tolower $winfutureleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue winfuture newsline) $arg"
}}}}}


proc postcszone { frombot command arg } {
global iscszoneleaf cszoneleafchans
if { $iscszoneleaf == "1" } {
putlog "($frombot) cszone: neue newsline"
foreach chan [channels] {
if { $cszoneleafchans == "" } {
putserv "privmsg $chan :(neue cszone newsline) $arg" }
if { $cszoneleafchans != "" } {
if {([lsearch -exact [string tolower $cszoneleafchans] [string tolower $chan]] != -1) } {
putserv "privmsg $chan :(neue cszone newsline) $arg"
}}}}}

putlog "*** newsleaf.tcl v1.3 by domsen succesfully loaded"

#[EOF]